function acidBase(ph, pco2, hco3, na, cl) {
    var bicarb = hco3;
    var whatText, expectedPco2, expectedText, phHigh, phLow, hco3High, hco3Low, ehco3, eph, eco2, agap;
    if ("" == ph || 0 >= ph || isNaN(ph)) {
        alert("Please enter the pH.");
        return "";
    }
    if ("" == pco2 || 0 >= pco2 || isNaN(pco2)) {
        alert("Please enter the pCO2.");
        return "";
    }
    if ("" == hco3 || 0 >= hco3 || isNaN(hco3)) {
        alert("Please enter the HCO3.");
        return "";
    }
    eph = 6.1 + Math.log(hco3 / (.0301 * pco2)) / Math.log(10);
    ehco3 = .0301 * Math.pow(10, ph - 6.1) * pco2;
    eco2 = hco3 / (.0301 * Math.pow(10, ph - 6.1));
    eph = roundNum(eph, 2);
    ehco3 = roundNum(ehco3, 0);
    eco2 = roundNum(eco2, 0);
    if (7.35 >= ph && 40 >= pco2) {
        whatText = "Primary metabolic acidosis";
        expectedPco2 = 1.5 * hco3 + 8;
        agap = anionGap(na, bicarb, cl, 1);
        if (16 >= agap) whatText += ", with normal anion gap"; else {
            whatText += ", with increased anion gap";
            var agapChange = agap - 12;
            var bicarbChange = 24 - hco3;
            agapChange - bicarbChange > 7 && (whatText += ",<br /> mixed with a metabolic alkalosis");
            -7 > agapChange - bicarbChange && (whatText += ",<br /> mixed with a normal-gap metabolic acidosis");
        }
    }
    if (ph > 7.44 && pco2 >= 40) {
        whatText = "Primary metabolic alkalosis";
        expectedPco2 = .7 * hco3 + 21;
    }
    expectedPco2 = roundNum(expectedPco2, 0);
    pco2 > expectedPco2 + 2 && (whatText += ",<br /> with secondary respiratory acidosis");
    expectedPco2 - 2 > pco2 && (whatText += ",<br /> with secondary respiratory alkalosis");
    expectedPco2 + 2 >= pco2 && pco2 >= expectedPco2 - 2 && (whatText += ",<br /> with full respiratory compensation");
    expectedText = "(expected Pco2 = " + (expectedPco2 - 2) + " - " + (expectedPco2 + 2) + ")";
    if (7.4 > ph && pco2 > 44) {
        whatText = "primary respiratory acidosis";
        phHigh = 7.4 - .003 * (pco2 - 40);
        phLow = 7.4 - .008 * (pco2 - 40);
        hco3High = 24 + .35 * (pco2 - 40);
        hco3Low = 24 + .1 * (pco2 - 40);
        phLow = roundNum(phLow, 2);
        phHigh = roundNum(phHigh, 2);
        hco3Low = roundNum(hco3Low, 0);
        hco3High = roundNum(hco3High, 0);
        if (phLow + .02 >= ph) {
            whatText = "Acute (uncompensated) " + whatText;
            if (hco3Low - 2 > hco3) {
                whatText += ",<br />with metabolic acidosis";
                agap = anionGap(na, bicarb, cl, 1);
                whatText += 16 >= agap ? ", with normal anion gap" : ", with increased anion gap";
            }
        }
        if (ph >= phHigh - .02001) {
            whatText = "Chronic (compensated) " + whatText;
            hco3 > hco3High + 2 && (whatText += ",<br />with metabolic alkalosis");
        }
        ph > phLow + .02 && phHigh - .02001 > ph && (whatText = "(1) partially compensated primary respiratory acidosis, or<br />(2) acute on chronic " + whatText + ", or<br />(3) mixed acute respiratory acidosis with a small metabolic alkalosis");
        expectedText = "pH &lt; " + phLow + " and HCO<sub>3</sub> &lt; " + hco3Low + ", for acute (uncompensated)<br />pH &gt; " + phHigh + " and HCO<sub>3</sub> &gt; " + hco3High + ", for chronic (compensated)";
    }
    if (ph > 7.4 && 36 > pco2) {
        whatText = "primary respiratory alkalosis";
        phLow = 7.4 + .0017 * (40 - pco2);
        phHigh = 7.4 + .008 * (40 - pco2);
        hco3Low = 24 - .5 * (40 - pco2);
        hco3High = 24 - .25 * (40 - pco2);
        phLow = roundNum(phLow, 2);
        phHigh = roundNum(phHigh, 2);
        hco3Low = roundNum(hco3Low, 0);
        hco3High = roundNum(hco3High, 0);
        if (phLow + .02 >= ph) {
            whatText = "Chronic (compensated) " + whatText;
            if (hco3Low - 2 > hco3) {
                whatText += ",<br /> with metabolic acidosis";
                agap = anionGap(na, bicarb, cl, 1);
                whatText += 16 >= agap ? ", with normal anion gap" : ", with increased anion gap";
            }
        }
        if (ph >= phHigh - .02) {
            whatText = "Acute (uncompensated) " + whatText;
            hco3 > hco3High + 2 && (whatText += ",<br /> with metabolic alkalosis");
        }
        ph > phLow + .02 && phHigh - .02 > ph && (whatText = "(1) partially-compensated primary respiratory alkalosis, or <br />(2) acute on chronic " + whatText + ", or <br />(3) mixed acute respiratory alkalosis with a small metabolic acidosis");
        expectedText = "pH > " + phHigh + " and HCO<sub>3</sub> > " + hco3High + ", for acute (uncompensated) <br />pH < " + phLow + " and HCO<sub>3</sub> < " + hco3Low + ", for chronic (compensated)";
    }
    if (("" == whatText || null == whatText) && ph >= 7.36 && 7.44 >= ph) {
        if (pco2 > 40 && hco3 > 26) {
            whatText = "Mixed respiratory acidosis / metabolic alkalosis";
            expectedPco2 = .7 * hco3 + 21;
        } else if (40 > pco2 && 22 > hco3) {
            whatText = "Mixed respiratory alkalosis / metabolic acidosis";
            expectedPco2 = 1.5 * hco3 + 8;
            agap = anionGap(na, bicarb, cl, 1);
            whatText += 16 >= agap ? ", with normal anion gap" : ", with increased anion gap";
        } else {
            agap = anionGap(na, bicarb, cl, 0);
            agap > 16 && (whatText = "Mixed metabolic alkalosis / metabolic acidosis, with increased anion gap");
        }
        expectedPco2 = roundNum(expectedPco2, 0);
        expectedText = "(expected P<sub>CO<sub>2</sub></sub> = " + (expectedPco2 - 2) + " - " + (expectedPco2 + 2) + ")";
    }
    if ("" == agap || null == agap) {
        agap = anionGap(na, bicarb, cl, 0);
        agap > 16 && (whatText += ",<br /> with metabolic acidosis, with increased anion gap");
    }
    if ("" == whatText || null == whatText) {
        whatText = "Normal ABG";
        expectedText = " ";
    }
    expectedText2 = "expected pH = " + eph + "<br />expected CO<sub>2</sub> = " + eco2 + "<br />expected HCO<sub>3</sub><sup>-</sup> = " + ehco3;
    return whatText;
}

function anionGap(na, bicarb, cl, metAcid) {
    var addText;
    addText = 1 == metAcid ? "METABOLIC ACIDOSIS<br />" : "";
    if ("" == na || null == na || 0 >= na || isNaN(na)) {
        if (0 == metAcid) return true;
        alert(addText + "Please enter a sodium value.");
        return false;
    }
    if ("" == bicarb || null == bicarb || 0 >= bicarb || isNaN(bicarb)) {
        if (0 == metAcid) return true;
        alert(addText + "Please enter a bicarbonate value.");
        return false;
    }
    if ("" == cl || null == cl || 0 >= cl || isNaN(cl)) {
        if (0 == metAcid) return true;
        alert(addText + "Please enter a chloride value.");
        return false;
    }
    var agap = na - bicarb - cl;
    return agap;
}

function roundNum(thisNum, dec) {
    thisNum *= Math.pow(10, dec);
    thisNum = Math.round(thisNum);
    thisNum /= Math.pow(10, dec);
    return thisNum;
}