function calcZoneFU(time, bili) {
    (12 > time || time > 144) && alert("Invalid times!");
    0 > bili && alert("Bilirubin level cannot be less than 0!");
    return aboveLine(time, bili, high_arr) ? 4 : aboveLine(time, bili, med_arr) ? 3 : aboveLine(time, bili, low_arr) ? 2 : 1;
}

function calcZonePhoto(time, bili) {
    (0 > time || time > 144) && alert("Invalid times!");
    0 > bili && alert("Bilirubin level cannot be less than 0!");
    return aboveLine(time, bili, high_photo_arr) ? 4 : aboveLine(time, bili, med_photo_arr) ? 3 : aboveLine(time, bili, low_photo_arr) ? 2 : 1;
}

function calcZoneExch(time, bili) {
    (0 > time || time > 144) && alert("Invalid times!");
    0 > bili && alert("Bilirubin level cannot be less than 0!");
    return aboveLine(time, bili, high_exch_arr) ? 4 : aboveLine(time, bili, med_exch_arr) ? 3 : aboveLine(time, bili, low_exch_arr) ? 2 : 1;
}

function aboveLine(x, y, lineArr) {
    for (var i = 1; i < lineArr.length; ++i) if (x < lineArr[i][0]) {
        var x1 = lineArr[i - 1][0], x2 = lineArr[i][0];
        var y1 = lineArr[i - 1][1], y2 = lineArr[i][1];
        var y_x = (y2 - y1) / (x2 - x1) * (x - x1) + y1;
        return y >= y_x;
    }
    return y > lineArr[lineArr.length - 1][1];
}

function calcY(x, arr) {
    for (var i = 1; i < arr.length; ++i) if (x < arr[i][0]) {
        var x1 = arr[i - 1][0], x2 = arr[i][0];
        var y1 = arr[i - 1][1], y2 = arr[i][1];
        return (y2 - y1) / (x2 - x1) * (x - x1) + y1;
    }
    if (x == arr[arr.length - 1][0]) return arr[arr.length - 1][1];
}

function calcPoints(time) {
    calcY(time, high_arr);
    calcY(time, high_photo_arr);
    return [ calcY(time, high_photo_arr), calcY(time, med_photo_arr), calcY(time, low_photo_arr) ];
}

function interpret(time, bili, gestAgeClass, totAge) {
    var fuClass = calcZoneFU(time, bili);
    var photoClass = calcZonePhoto(time, bili);
    var exchClass = calcZoneExch(time, bili);
    var sPhoto = "<span class='blue'>Therapy:</span> ";
    var sFU = "<br /><br /><span class='blue'>Follow-up:</span> ";
    var sFU_none = "No specifically recommended follow up.";
    var str = "";
    str += sPhoto;
    if (4 == exchClass) str += "Start both phototherapy and exchange transfusion!"; else if (4 == photoClass) str += "Start phototherapy. Exchange transfusion not indicated at this time."; else if (3 == photoClass) if (4 == fuClass) {
        if (2 == gestAgeClass) str += 3 == exchClass ? "Start phototherapy and exchange transfusion if neonate has neurotoxicity risk factor(s)." : "Start phototherapy if neonate has neurotoxicity risk factor(s)."; else {
            str += "Start phototherapy";
            3 == exchClass ? str += " and exchange transfusion" : 2 == exchClass && (str += ". Start exchange transfusion if neonate has neurotoxicity risk factor(s)");
            str += ".";
        }
        str += sFU;
        str += "Recheck bilirubin level in 4-24 hours.";
    } else if (2 == gestAgeClass) {
        str += "Phototherapy not indicated.";
        str += sFU;
        str += "If neonate has hyperbilirubinemia risk factor(s), recheck within 24 hours. Otherwise, within 48 hours.";
    } else {
        str += "Start phototherapy if neonate has neurotoxicity risk factor(s).";
        str += sFU;
        str += "If neonate has hyperbilirubinemia risk factor(s), recheck in 4-24 hours. Otherwise, within 24 hours.";
    } else if (2 == photoClass) if (fuClass >= 3) if (2 == gestAgeClass) {
        str += "Phototherapy not indicated.";
        str += sFU;
        str += "If neonate has hyperbilirubinemia risk factor(s), recheck within 24 hours. Otherwise, within 48 hours.";
    } else {
        str += "Start phototherapy if neonate has neurotoxicity risk factor(s).";
        str += sFU;
        str += "If neonate has hyperbilirubinemia risk factor(s), recheck in 4 - 24 hours. Otherwise, within 24 hours.";
    } else if (2 == gestAgeClass) {
        str += "Phototherapy not indicated.";
        str += sFU;
        str += 72 > totAge ? "If neonate has hyperbilirubinemia risk factor(s), within 48 hours. Otherwise, base on age and other clinical concerns." : sFU_none;
    } else {
        str += "Start phototherapy if neonate has neurotoxicity risk factor(s).";
        str += sFU;
        str += 72 > totAge ? "If hyperbilirubinemia risk factor(s), recheck within 48 hours." : sFU_none;
    } else if (fuClass >= 2) {
        str += "Phototherapy not indicated.";
        str += sFU;
        str += totAge >= 72 ? sFU_none : 2 == gestAgeClass ? "According to age and other clinical concerns." : "Within 48 hours.";
    } else {
        str += "Phototherapy not indicated.";
        str += sFU;
        str += totAge >= 72 ? sFU_none : 2 == gestAgeClass ? "According to age and other clinical concerns." : "If hyperbilirubinemia risk factor(s), within 48 hours. Otherwise, within 48-72 hours.";
    }
    return str;
}

var high_arr = [ [ 12, 7 ], [ 24, 7.8 ], [ 40, 12.1 ], [ 44, 12.5 ], [ 60, 15.1 ], [ 96, 17.4 ], [ 120, 17.7 ], [ 144, 17.2 ] ];

var med_arr = [ [ 12, 5 ], [ 18, 5.9 ], [ 24, 6.05 ], [ 40, 10 ], [ 44, 10.2 ], [ 60, 12.6 ], [ 72, 13.4 ], [ 84, 14.7 ], [ 96, 15.2 ], [ 120, 15.9 ], [ 144, 15.2 ] ];

var low_arr = [ [ 12, 4 ], [ 18, 4.7 ], [ 24, 4.95 ], [ 40, 7.8 ], [ 60, 9.6 ], [ 72, 11.2 ], [ 84, 11.6 ], [ 96, 12.4 ], [ 120, 13.3 ], [ 144, 13.2 ] ];

var low_photo_arr = [ [ 0, 3.8 ], [ 12, 6 ], [ 48, 11.2 ], [ 70, 13.3 ], [ 106, 14.8 ], [ 120, 15 ], [ 144, 15 ] ];

var med_photo_arr = [ [ 0, 5 ], [ 12, 7.6 ], [ 24, 9.9 ], [ 36, 11.6 ], [ 60, 14.5 ], [ 108, 18 ], [ 144, 18 ] ];

var high_photo_arr = [ [ 0, 6.6 ], [ 12, 9 ], [ 24, 11.6 ], [ 48, 15.2 ], [ 96, 19.8 ], [ 106, 21 ], [ 144, 21 ] ];

var low_exch_arr = [ [ 0, 12 ], [ 24, 15 ], [ 58, 16.9 ], [ 70, 18.5 ], [ 96, 19 ], [ 144, 19 ] ];

var med_exch_arr = [ [ 0, 13.9 ], [ 48, 19 ], [ 72, 21.2 ], [ 84, 22 ], [ 96, 22.5 ], [ 144, 22.5 ] ];

var high_exch_arr = [ [ 0, 16 ], [ 36, 20.9 ], [ 48, 22.1 ], [ 72, 24 ], [ 96, 25 ], [ 144, 25 ] ];