function getWt() {
    return weight;
}

function setupDisplay() {
    $("#medications").html(stringifyMedList());
    $("#medications").listview("refresh");
    bindMedEvents();
}

function changeSliderColor(wt) {
    36 >= wt ? $("#wtSlider").css("background-image", "none") : $("#wtSlider").css("background-image", bgImg);
    5 >= wt ? $("#wtSlider").css("background-color", "#A7A7A7") : 7 >= wt ? $("#wtSlider").css("background-color", "#FFA8E7") : 9 >= wt ? $("#wtSlider").css("background-color", "#BA0104") : 11 >= wt ? $("#wtSlider").css("background-color", "#DD95FF") : 14 >= wt ? $("#wtSlider").css("background-color", "#EFE90D") : 18 >= wt ? $("#wtSlider").css("background-color", "white") : 23 >= wt ? $("#wtSlider").css("background-color", "#2F75FF") : 29 >= wt ? $("#wtSlider").css("background-color", "#FFA732") : 36 >= wt ? $("#wtSlider").css("background-color", "#40DE36") : $("#wtSlider").css("background-color", "#0BA949");
}

function loadMeds() {
    var counter = 0;
    medsSet = new Object();
    var counter = 0;
    for (var i = 0; i < fileArr.length; ++i) $.when(loadXML(fileArr[i])).then(function() {
        ++counter;
        counter == fileArr.length && setupDisplay();
    });
}

function loadXML(file) {
    return $.ajax({
        type: "GET",
        url: file,
        dataType: "xml",
        success: parseXML,
        error: function() {
            alert("The XML File could not be processed correctly. File name = " + file);
        }
    });
}

function parseXML(xml) {
    var med, mClass, wtDose, roundTo, maxDose;
    $("med", xml).each(function() {
        try {
            mClass = $(this).attr("class");
            mClass && 0 != mClass.length || (mClass = "Med");
            med = new window[mClass]();
            med.genericName = $(this).find("generic").text();
            med.tradeName = $(this).find("trade").text();
            med.route = $(this).find("route").text();
            med.freq = $(this).find("frequency").text();
            med.units = $(this).find("units").text();
            med.indication = $(this).find("indication").text();
            med.notes = $(this).find("notes").text();
            med.notes2 = $(this).find("notes2").text();
            med.tags = $(this).find("tags").text();
            med.pregnancy = $(this).find("pregnancy").text();
            med.lactation = $(this).find("lactation").text();
            $(this).attr("pedsDosing") && (med.bPedsDosing = "true" == $(this).attr("pedsDosing").toLowerCase());
            wtDose = parseFloat($(this).find("wtDose").text());
            roundTo = parseFloat($(this).find("roundTo").text());
            maxDose = parseFloat($(this).find("maxDose").text());
            wtDose && (med.stdWtDose = wtDose);
            roundTo && (med.roundTo = roundTo);
            maxDose && (med.stdDose = maxDose);
            med instanceof MedLiquid && (med.stdTspStrength = parseFloat($(this).find("liquidStrength").text()));
            if (med instanceof MedLiquidMultipleStrengths) {
                var strArr = [];
                $(this).find("form").each(function() {
                    strArr.push(parseFloat($(this).text()));
                });
                med.tspStrArr = strArr;
                med.stdTspStrength = strArr[0];
            }
            if (med instanceof MedLimitedDoses) {
                var strArr = [];
                $(this).find("form").each(function() {
                    strArr.push(parseFloat($(this).text()));
                });
                med.doses = strArr;
            }
            if (med instanceof MedMultipleStrengths) {
                var strArr = [];
                var wt, mx, un, rt, freq;
                $(this).find("form").each(function() {
                    wt = parseFloat($(this).find("wtDose").text());
                    isNaN(wt) && (wt = med.stdWtDose);
                    mx = parseFloat($(this).find("maxDose").text());
                    isNaN(mx) && (mx = med.stdDose);
                    un = $(this).find("units").text();
                    un && 0 != un.length || (un = med.units);
                    rt = $(this).find("route").text();
                    rt && 0 != rt.length || (rt = med.route);
                    freq = $(this).find("frequency").text();
                    freq && 0 != freq.length || (freq = med.freq);
                    strArr.push([ $(this).find("title").text(), wt, mx, un, rt, freq ]);
                });
                med.setStrArr(strArr);
            }
            if (med instanceof MedBland) {
                var strArr = [];
                $(this).find("form").each(function() {
                    strArr.push([ $(this).find("title").text(), $(this).find("string").text() ]);
                });
                med.dosing = 1 == strArr.length ? strArr[0][1] : strArr;
                med.setCurDosing();
            }
            medsSet[med.getID()] = med;
        } catch (e) {
            alert("Unable to load a Medication!<br />" + med.genericName);
        }
    });
}

function stringifyMedList() {
    var str = "";
    var wt = getWt();
    var counter = 0;
    var mID;
    for (mID in medsSet) if (medsSet.hasOwnProperty(mID)) {
        str += '<li id="' + mID + '">' + medHtml(medsSet[mID], wt) + "</li>";
        ++counter;
    }
    $("#counter").html(counter);
    return str;
}

function medHtml(med, wt) {
    var str = med.printRx(wt) + med.getIndication();
    str += "<span style='display:none'>" + med.tags + "</span>";
    return str;
}

function changeDosing() {
    updateDose($(this).attr("id").split("-sel")[0], getWt());
}

function bindMedEvents() {
    var mID;
    var med;
    $(document).on("click", ".generic", loadPopup);
    for (mID in medsSet) {
        med = medsSet[mID];
        try {
            (med instanceof MedLiquidMultipleStrengths || med instanceof MedMultipleStrengths || med instanceof MedBland) && $(document).on("change", "#" + mID + "-sel", changeDosing);
        } catch (e) {
            alert(e);
        }
    }
}

function searchItem(index, searchStr, obj) {
    obj || (obj = $("#medications").children().eq(index));
    if (0 == searchStr.length) return true;
    var bool = -1 === obj.html().toLowerCase().indexOf(searchStr.toLowerCase());
    bool || updateDose($(obj).attr("id"), getWt());
    return bool;
}

function updateDose(medID, wt) {
    med = medsSet[medID];
    var str = medHtml(med, wt);
    $("#" + medID).html(str);
}

function changeWt() {
    weight = parseInt($("#wt").val());
    var searchText = $("#search_bar").val();
    var n = 0;
    var children = $("#medications").children();
    children.length;
    for (var n = 0; n < children.length; ++n) searchItem(n, searchText, children.eq(n));
    changeSliderColor(weight);
}

function loadPopup() {
    var medID = $(this).attr("id").split("-name")[0];
    var med = medsSet[medID];
    var str = "";
    str += "Generic Name: <span class='blue'>" + med.genericName + "</span><br />";
    med.tradeName && med.tradeName.length > 0 && (str += "Trade Name: <span class='blue'>" + med.tradeName + "</span><br />");
    med.pregnancy && med.pregnancy.length > 0 && (str += "Pregnancy Class: <span class='blue'>" + med.pregnancy + "</span><br />");
    med.lactation && med.lactation.length > 0 && (str += "Lactation: <span class='blue'>" + med.lactation + "</span><br />");
    med.indication && med.indication.length > 0 && (str += "Indications: <span class='blue'>" + med.indication + "</span><br />");
    med.notes && med.notes.length > 0 && (str += "Notes: <span class='blue'>" + med.notes + "</span><br />");
    med.notes2 && med.notes2.length > 0 && (str += "Other info: <span class='blue'>" + med.notes2 + "</span><br />");
    med.source && med.source.length > 0 && (str += "Source(s): <span class='blue'>" + med.source + "</span>");
    $("#popupText").html(str);
    $("#popup").popup("open");
}

var medsSet;

var bgImg;

var weight;

var fileArr = [ "../meds/med_list.xml", "../meds/med_list_tox.xml", "../meds/med_list_neuro.xml", "../meds/med_list_cards.xml", "../meds/med_list_abx.xml", "../meds/med_list_peds.xml", "../meds/med_list_test.xml" ];

$.mobile.filterable.prototype.options.filterCallback = searchItem;