function getWt() {
    return parseInt($("#wt").val());
}

function setupDisplay() {
    $("#medications").html("");
    $("#medications").listview("refresh");
}

function changeSliderColor(wt) {
    36 >= wt ? $("#wtSlider").css("background-image", "none") : $("#wtSlider").css("background-image", bgImg);
    5 >= wt ? $("#wtSlider").css("background-color", "#A7A7A7") : 7 >= wt ? $("#wtSlider").css("background-color", "#FFA8E7") : 9 >= wt ? $("#wtSlider").css("background-color", "#BA0104") : 11 >= wt ? $("#wtSlider").css("background-color", "#DD95FF") : 14 >= wt ? $("#wtSlider").css("background-color", "#EFE90D") : 18 >= wt ? $("#wtSlider").css("background-color", "white") : 23 >= wt ? $("#wtSlider").css("background-color", "#2F75FF") : 29 >= wt ? $("#wtSlider").css("background-color", "#FFA732") : 36 >= wt ? $("#wtSlider").css("background-color", "#40DE36") : $("#wtSlider").css("background-color", "#0BA949");
    if (wt > 11 && 18 >= wt) {
        $("#wtTxt").css("color", "black");
        $("#wtLbs").css("color", "#666");
    } else {
        $("#wtTxt").css("color", "white");
        $("#wtLbs").css("color", "#e0e0ff");
    }
}

function loadMeds() {
    var counter = 0;
    medsSet = new Object();
    medsList = [];
    var counter = 0;
    for (var i = 0; i < fileArr.length; ++i) $.when(loadXML(fileArr[i])).then(function() {
        ++counter;
        counter == fileArr.length && setupDisplay();
    });
    $(document).on("click", ".generic", loadPopup);
}

function loadXML(file) {
    return $.ajax({
        type: "GET",
        url: file,
        dataType: "xml",
        success: parseXML,
        error: function() {
            alert("The XML File could not be processed correctly. File name = " + file);
        }
    });
}

function parseXML(xml) {
    var med, mClass, wtDose, roundTo, maxDose;
    $("med", xml).each(function() {
        try {
            mClass = $(this).attr("class");
            mClass && 0 != mClass.length || (mClass = "Med");
            med = new window[mClass]();
            med.genericName = $(this).find("generic").text();
            med.tradeName = $(this).find("trade").text();
            med.route = $(this).find("route").text();
            med.freq = $(this).find("frequency").text();
            med.units = $(this).find("units").text();
            med.indication = $(this).find("indication").text();
            med.notes = $(this).find("notes").text();
            med.notes2 = $(this).find("notes2").text();
            med.tags = $(this).find("tags").text();
            med.pregnancy = $(this).find("pregnancy").text();
            med.lactation = $(this).find("lactation").text();
            med.source = $(this).find("source").text();
            med.mech = $(this).find("mech").text();
            med.halflife = $(this).find("halflife").text();
            med.special = $(this).find("special").text();
            $(this).attr("pedsDosing") && (med.bPedsDosing = "true" == $(this).attr("pedsDosing").toLowerCase());
            wtDose = parseFloat($(this).find("wtDose").text());
            roundTo = parseFloat($(this).find("roundTo").text());
            maxDose = parseFloat($(this).find("maxDose").text());
            wtDose && (med.stdWtDose = wtDose);
            roundTo && (med.roundTo = roundTo);
            maxDose && (med.stdDose = maxDose);
            med instanceof MedLiquid && (med.stdTspStrength = parseFloat($(this).find("liquidStrength").text()));
            if (med instanceof MedLiquidMultipleStrengths) {
                var strArr = [];
                $(this).find("form").each(function() {
                    strArr.push(parseFloat($(this).text()));
                });
                med.tspStrArr = strArr;
                med.stdTspStrength = strArr[0];
            }
            if (med instanceof MedLimitedDoses) {
                var strArr = [];
                $(this).find("form").each(function() {
                    strArr.push(parseFloat($(this).text()));
                });
                med.doses = strArr;
            }
            if (med instanceof MedMultipleStrengths) {
                var strArr = [];
                var wt, mx, un, rt, freq;
                $(this).find("form").each(function() {
                    wt = parseFloat($(this).find("wtDose").text());
                    isNaN(wt) && (wt = med.stdWtDose);
                    mx = parseFloat($(this).find("maxDose").text());
                    isNaN(mx) && (mx = med.stdDose);
                    un = $(this).find("units").text();
                    un && 0 != un.length || (un = med.units);
                    rt = $(this).find("route").text();
                    rt && 0 != rt.length || (rt = med.route);
                    freq = $(this).find("frequency").text();
                    freq && 0 != freq.length || (freq = med.freq);
                    strArr.push([ $(this).find("title").text(), wt, mx, un, rt, freq ]);
                });
                med.setStrArr(strArr);
            }
            if (med instanceof MedBland) {
                var strArr = [];
                $(this).find("form").each(function() {
                    strArr.push([ $(this).find("title").text(), $(this).find("string").text() ]);
                });
                med.dosing = 1 == strArr.length ? strArr[0][1] : strArr;
                med.setCurDosing();
            }
            medsList.push([ medHtml(med, 70), med ]);
            medsSet[med.getID()] = med;
        } catch (e) {
            alert("Unable to load a Medication!<br />" + med.genericName);
        }
    });
}

function stringifyMed(med, wt) {
    return '<li id="' + med.getID() + '" class="ui-li-static ui-body-inherit">' + medHtml(med, wt) + "</li>";
}

function stringifyMedsList() {
    var str = "";
    var wt = getWt();
    for (var i = 0; i < visibleMedsList.length; ++i) str += stringifyMed(visibleMedsList[i][1], wt);
    $("#medications").html(str);
}

function medHtml(med, wt) {
    var str = med.printRx(wt) + med.getIndication();
    str += "<span style='display:none'>" + med.tags + "</span>";
    return str;
}

function changeDosing() {
    updateDose($(this).attr("id").split("-sel")[0], getWt());
}

function bindMedEvents() {
    var med;
    for (var i = 0; i < visibleMedsList.length; ++i) {
        med = visibleMedsList[i][1];
        try {
            (med instanceof MedLiquidMultipleStrengths || med instanceof MedMultipleStrengths || med instanceof MedBland) && $(document).on("change", "#" + med.getID() + "-sel", changeDosing);
        } catch (e) {
            alert(e);
        }
    }
}

function runSearch() {
    var s = $("#search_bar").val().toLowerCase();
    $("#counter").html(s);
    visibleMedsList = [];
    if (s.length > 1) for (var i = 0; i < medsList.length; ++i) -1 === medsList[i][0].toLowerCase().indexOf(s) || visibleMedsList.push(medsList[i]);
    stringifyMedsList();
    bindMedEvents();
}

function searchChange() {
    var x = $("#search_bar").val().length;
    if (0 == x && bSearchStr) {
        $("#medications").css("display", "none");
        $("#tutorial").fadeIn();
        $("#medications").html("");
        bSearchStr = false;
    } else if (x > 0 && !bSearchStr) {
        $("#tutorial").fadeOut();
        $("#medications").css("display", "block");
        bSearchStr = true;
    }
    x > 0 && runSearch();
}

function clearSearch() {
    $("#search_bar").val("");
    searchChange();
}

function updateDose(medID, wt) {
    med = medsSet[medID];
    var str = medHtml(med, wt);
    $("#" + medID).html(str);
}

function changeWt() {
    var wt = getWt();
    $("#lbs").html(Math.round(2.2 * wt));
    var med;
    for (var i = 0; i < visibleMedsList.length; ++i) {
        med = visibleMedsList[i][1];
        $("#" + med.getID()).html(medHtml(med, wt));
    }
    changeSliderColor(wt);
}

function loadPopup() {
    var medID = $(this).attr("id").split("-name")[0];
    var med = medsSet[medID];
    var str = "";
    str += "Generic Name: <span class='blue'>" + med.genericName + "</span><br />";
    med.tradeName && med.tradeName.length > 0 && (str += "Trade Name: <span class='blue'>" + med.tradeName + "<sup>&reg;</sup></span><br />");
    med.pregnancy && med.pregnancy.length > 0 && (str += "Pregnancy Class: <span class='blue'>" + med.pregnancy + "</span><br />");
    med.lactation && med.lactation.length > 0 && (str += "Lactation: <span class='blue'>" + med.lactation + "</span><br />");
    med.indication && med.indication.length > 0 && (str += "Indications: <span class='blue'>" + med.indication + "</span><br />");
    med.notes && med.notes.length > 0 && (str += "Notes: <span class='blue'>" + med.notes + "</span><br />");
    med.notes2 && med.notes2.length > 0 && (str += "Other info: <span class='blue'>" + med.notes2 + "</span><br />");
    med.mech && med.mech.length > 0 && (str += "Mechanism: <span class='blue'>" + med.mech + "</span><br />");
    med.halflife && med.halflife.length > 0 && (str += "Half-life: <span class='blue'>" + med.halflife + "</span><br />");
    med.source && med.source.length > 0 && (str += "Source(s): <span class='blue'>" + med.source + "</span>");
    $("#popupText").html(str);
    $("#popup").popup("open");
}

var medsSet;

var medsList = [];

var visibleMedsList = [];

var bgImg;

var fileArr = [ "../meds/med_list.xml", "../meds/med_list_tox.xml", "../meds/med_list_neuro.xml", "../meds/med_list_cards.xml", "../meds/med_list_abx.xml", "../meds/med_list_peds.xml", "../meds/med_list_test.xml" ];

var delay = function() {
    var timer = 0;
    return function(callback, ms) {
        clearTimeout(timer);
        timer = setTimeout(callback, ms);
    };
}();